package biz.capitalware.mqfm.action.objects;

import java.util.ArrayList;

import biz.capitalware.mqfm.mq.objects.QueueObject;
import biz.capitalware.mqfm.objects.Constants;

public abstract class FMFileMQObject extends FMFileObject
{
   public String           mqXMLFile   = null;
   public String           CCDTFile    = null;
   public String           qMgrName    = null;
   public QueueObject      qObject     = null;
   
   public int              msgCount    = 0;

   /**
    * The constructor
    */
   public FMFileMQObject()
   {
      super();
   }

   /**
    * Build XML tags from MQ values.
    * @return
    */
   public ArrayList<String> createMQTag()
   {
      ArrayList<String> al = new ArrayList<String>();
      
      if ((mqXMLFile != null) || (CCDTFile != null) || (qMgrName != null) || (qObject != null) )
      {   
         al.add("  <"+Constants.MQ_ELEMENT+">"+LINE_SEPARATOR);
   
         if (mqXMLFile != null)
            al.add("    <"+Constants.MQFILE_ELEMENT+">"+mqXMLFile+"</"+Constants.MQFILE_ELEMENT+">"+LINE_SEPARATOR);
         
         if (CCDTFile != null)
            al.add("    <"+Constants.CCDTFILE_ELEMENT+">"+CCDTFile+"</"+Constants.CCDTFILE_ELEMENT+">"+LINE_SEPARATOR);
         
         if (qMgrName != null)
            al.add("    <"+Constants.QMGRNAME_ELEMENT+">"+qMgrName+"</"+Constants.QMGRNAME_ELEMENT+">"+LINE_SEPARATOR);
         
         if (qObject != null)
         {
            if (qObject.qName != null)
            {
               if (qObject.qMgrName != null)
                  al.add("    <"+Constants.QUEUENAME_ELEMENT+" "+Constants.QMGRNAME_ATTRIBUTE+"=\""+qObject.qMgrName+"\">"+qObject.qName+"</"+Constants.QUEUENAME_ELEMENT+">"+LINE_SEPARATOR);
               else
                  al.add("    <"+Constants.QUEUENAME_ELEMENT+">"+qObject.qName+"</"+Constants.QUEUENAME_ELEMENT+">"+LINE_SEPARATOR);
            }
         }
         
         al.add("  </"+Constants.MQ_ELEMENT+">"+LINE_SEPARATOR);
      }
      
      return al;
   }

   /**
    * Build XML tags from Remote values.
    * @param remoteQMgrName
    * @return
    */
   public ArrayList<String> createRemoteTag(String remotejobXmlFile, String remoteDirectory, String remoteFilename)
   {
      ArrayList<String> al = new ArrayList<String>();
      
      if ((remotejobXmlFile != null) || (remoteDirectory != null) || (remoteFilename != null) )
      {   
         al.add("  <"+Constants.REMOTE_ELEMENT+">"+LINE_SEPARATOR);
   
         if (remotejobXmlFile != null)
            al.add("    <"+Constants.EXECUTE_ELEMENT+">"+remotejobXmlFile+"</"+Constants.EXECUTE_ELEMENT+">"+LINE_SEPARATOR);
         
         if (remoteDirectory != null)
            al.add("    <"+Constants.DIRECTORY_ELEMENT+">"+remoteDirectory+"</"+Constants.DIRECTORY_ELEMENT+">"+LINE_SEPARATOR);
         
         if (remoteFilename != null)
            al.add("    <"+Constants.FILENAME_ELEMENT+">"+remoteFilename+"</"+Constants.FILENAME_ELEMENT+">"+LINE_SEPARATOR);
         
         al.add("  </"+Constants.REMOTE_ELEMENT+">"+LINE_SEPARATOR);
      }
      
      return al;
   }
}
