package biz.capitalware.mqfm.action.objects;

import java.util.ArrayList;

/**
 * This class holds the values for the OnError object.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class OnErrorObject extends FMObject
{
   public ExecuteObject    eo;
   public SendEmailObject  seo;

   /**
    * The constructor
    */
   public OnErrorObject()
   {
      super();
   }

   /**
    * Process tokens in Action Object's variables
    */
   public void performTokenization()
   {
      
   }

   /**
    * Verify the values in the object.
    */
   public void checkObject()
   {
      if (eo != null)
         eo.checkObject();

      if (seo != null)
         seo.checkObject();
   }

   /**
    * Output the info
    * @param logger
    */
   public void printValues()
   {
      if (eo != null)
         eo.printValues();
      
      if (seo != null)
         seo.printValues();
   }
   
   /**
    * Convert the object to a string.
    * @return s
    */
   public ArrayList<String> toStringArray()
   {
      ArrayList<String> al = new ArrayList<String>();

      if (eo != null)
      {
         ArrayList<String> xx = eo.toStringArray();
         for (int i=0; i < xx.size(); i++)
            al.add(xx.get(i));
      }
      
      if (seo != null)
      {
         ArrayList<String> xx = seo.toStringArray();
         for (int i=0; i < xx.size(); i++)
            al.add(xx.get(i));
      }

      return al;
   }
}
