package biz.capitalware.mqfm.action.objects;

import java.util.ArrayList;

import biz.capitalware.mqfm.MQFM;
import biz.capitalware.mqfm.handlers.Tokens;
import biz.capitalware.mqfm.objects.Constants;

/**
 * This class holds the values for the Schedule action.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class ScheduleObject extends FMObject
{
   public String  xmlFile = null;

   /**
    * The constructor
    */
   public ScheduleObject()
   {
      super();
   }

   /**
    * Process tokens in Action Object's variables
    */
   public void performTokenization()
   {
      if (xmlFile != null)
         xmlFile = Tokens.replace(xmlFile, MQFM.userProperties);
   }

   /**
    * Verify the values in the object.
    */
   public void checkObject()
   {
      if (xmlFile == null)
         throw new IllegalArgumentException("Error: You must specify a xmlFile for the SendEmail action.");
   }

   /**
    * Output the info
    * @param logger
    */
   public void printValues()
   {
      MQFM.logger.info("     XML File             = " + xmlFile);
   }
   
   /**
    * Convert the object to a string.
    * @return s
    */
   public ArrayList<String> toStringArray()
   {
      ArrayList<String> al = new ArrayList<String>();
      
      al.add("<"+Constants.SCHEDULE_ELEMENT+" "+Constants.XML_FILE_ATTRIBUTE+"=\""+xmlFile+"\" />"+LINE_SEPARATOR);
      
      return al;
   }
}
