package biz.capitalware.mqfm.actions;

import biz.capitalware.mqfm.action.objects.AppendObject;
import biz.capitalware.mqfm.handlers.IO;
import biz.capitalware.mqfm.objects.MQFMException;

/**
 * This class will handle the append action.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class AppendAction extends FMAction
{
   private AppendObject   ao;

   /**
    * The constructor
    * @param ao
    * @param logger
    */
   public AppendAction(AppendObject ao)
   {
      super(ao.actionName);
      this.ao = ao;
   }

   /**
    * Perform the copy work.
    */
   public int doWork()
   {
      int exitCode = 0;
      ao.printValues();
         
      try
      {
         IO.appendFile(ao.srcFilename, ao.toFilename);
         ao.fileCount++;
      }
      catch (MQFMException e)
      {
         if (ao.onErrorFail)
            exitCode = 8;
      }
      
      return exitCode;
   }
}
