package biz.capitalware.mqfm.actions;

import java.io.IOException;

import org.jdom.JDOMException;

import biz.capitalware.mqfm.action.objects.ExecuteObject;
import biz.capitalware.mqfm.handlers.RunJob;
import biz.capitalware.mqfm.MQFM;

/**
 * This class will handle executing a command action.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class ExecuteAction extends FMAction
{
   private ExecuteObject   eo;

   public ExecuteAction(ExecuteObject eo)
   {
      super(eo.actionName);
      this.eo = eo;
   }

   public int doWork()
   {
      int exitCode = 0;
      eo.printValues();

      RunJob rj = new RunJob();
      
      try
      {
         rj.launch(eo.xmlFile);
      }
      catch (JDOMException e)
      {
         MQFM.logger.fatal("JDOMException: "+e.getLocalizedMessage());
         if (e.getCause() != null)
            MQFM.logger.fatal(e.getCause().toString());;
         exitCode = 8;
      }
      catch (IOException e)
      {
         MQFM.logger.fatal("IOException: "+e.getLocalizedMessage());
         if (e.getCause() != null)
            MQFM.logger.fatal(e.getCause().toString());;
         exitCode = 8;
      }

      if (!eo.onErrorFail)
         exitCode = 0; /* reset back to zero */

      return exitCode;
   }
}
