package biz.capitalware.mqfm.actions;

import biz.capitalware.mqfm.MQFM;
import biz.capitalware.mqfm.action.objects.LaunchObject;
import biz.capitalware.mqfm.objects.Constants;

/**
 * This class will handle executing an action command.
 *
 * @author Roger Lacroix
 * @version 1.0
 * @license Apache 2 License
 */
public class LaunchAction extends FMAction
{
   private LaunchObject   lo;

   public LaunchAction(LaunchObject lo)
   {
      super(lo.actionName);
      this.lo = lo;
   }

   /**
    * Perform schedule work.
    */
   public int doWork()
   {
      int exitCode = 0;
      lo.printValues();

      MQFM.logger.info("Launch Action is starting: " + lo.xmlFile);
      MQFM fm = new MQFM();
      fm.setXmlFilename(lo.xmlFile);
      exitCode = fm.doWork(Constants.ONE_PASS, false);
      
      if (!lo.onErrorFail)
         exitCode = 0; /* reset back to zero */

      return exitCode;
   }
}
